Ubuntu系统-FFmpeg安装及环境配置

  • Ubuntu系统-FFmpeg安装及环境配置已关闭评论
  • 33 次浏览
  • A+
所属分类:linux技术
摘要

镜像下载、域名解析、时间同步请点击 阿里云开源镜像站FCN-4是一个应用于音频自动标注的全卷积神经网络。使用该网络完成音频标注任务时,首先需要使用python的音频处理工具包Librosa提取音频的时频特征,针对mp3格式的音频文件,Librosa读取音频文件的工作依赖音频处理后端ffmpeg完成,因此要求使用该网络进行mp3音频自动标注任务的环境具备Librosa依赖库和ffmpeg。

镜像下载、域名解析、时间同步请点击 阿里云开源镜像站

1 简介

FCN-4是一个应用于音频自动标注的全卷积神经网络。使用该网络完成音频标注任务时,首先需要使用python的音频处理工具包Librosa提取音频的时频特征,针对mp3格式的音频文件,Librosa读取音频文件的工作依赖音频处理后端ffmpeg完成,因此要求使用该网络进行mp3音频自动标注任务的环境具备Librosa依赖库和ffmpeg。

  • Librosa是一个用于音频、音乐分析、处理的python工具包,具备时频处理、特征提取、绘制声音图形等常用功能。

  • FFmpeg是处理多媒体内容(如音频、视频、字幕和相关元数据)的库和工具的集合,它包含包含了先进的音视频编解码库,提供了录制、转换以及流传输音视频的完整跨平台解决方案。可以使用它的API对音视频进行处理,也可以使用它提供的工具,如 ffmpeg, ffplay, ffprobe,来编辑音视频文件。

以下对Librosa库和FFmpeg工具在安装配置过程中的常见问题进行说明。

2 安装Librosa依赖库的常见问题

2.1 Librosa库的安装

  • 当执行含有“import librosa”语句的python脚本时,报错如下图所示,说明需要安装Librosa依赖库。

Ubuntu系统-FFmpeg安装及环境配置

  • 命令行执行以下命令安装librosa库
    pip install librosa 

安装结果中出现红框中的提示内容,说明librosa依赖库安装成功。

Ubuntu系统-FFmpeg安装及环境配置

2.2 调用librosa包的过程中可能出现的错误

安装好librosa依赖库后,仍可能存在环境中缺少其他相关依赖的问题,以下给出可能存在的问题及其解决方案

2.2.1 没有bz2模块

  • 报错

报错“ No modual named ‘_bz2’ ”。如下所示

Ubuntu系统-FFmpeg安装及环境配置

  • 可能原因

出现这个错误的原因是由于运行程序所使用的python版本中没有安装_bz2库所致。

通常是由于运行程序使用的是python3.7,但是bz2这个库是安装到了python3.6的路径下,所以找不到。

  • 解决方案

将python3.6里面的bz2库拷贝到python3.7下面。

操作步骤:

1.找到python3.6路径下的_bz2库文件,即“_bz2.cpython-36m-x86_64-linux-gnu.so”

ll /usr/lib/python3.6/lib-dynload/ 

Ubuntu系统-FFmpeg安装及环境配置

2.切换到python3.7对应路径,将该文件复制到该目录下

cd /usr/local/python3.7.5/lib/python3.7/lib-dynload/ cp /usr/lib/python3.6/lib-dynload/_bz2.cpython-36m-x86_64-linux-gnu.so ./ 

3.修改文件名称,将"-36m"修改为"-37m"

mv _bz2.cpython-36m-x86_64-linux-gnu.so _bz2.cpython-37m-x86_64-linux-gnu.so chmod +x _bz2.cpython-37m-x86_64-linux-gnu.so    # (可选)增加该文件的可执行权限  

现在运行程序所使用的是python3.7的目录下已经有了bz库文件

Ubuntu系统-FFmpeg安装及环境配置

说明:

该问题有多种解决方案,只要保证所使用的python版本相关路径下存在_bz2库即可。例如可以从网上下载“_bz2.cpython-37m-x86_64-linux-gnu.so”文件,或从任意其他存在该文件的环境中复制到目标环境的相关路径下即可。

2.2.2 没有_lzma模块

  • 报错

报错“ No module named ‘_lzma’ ”。如下所示

Ubuntu系统-FFmpeg安装及环境配置

  • 解决方案

请参考上一步骤“2.2.1 没有bz2模块”解决,保证所使用的python版本相关路径下存在lzma库即可。

Ubuntu系统-FFmpeg安装及环境配置

2.2.3 找不到sndfile库

  • 报错“OSError: sndfile library not found”。如下所示。

Ubuntu系统-FFmpeg安装及环境配置

  • 解决方案

命令行执行以下命令安装sndfile库

apt-get install libsndfile1 

Ubuntu系统-FFmpeg安装及环境配置

Ubuntu系统-FFmpeg安装及环境配置

3 安装FFmpeg工具的常见问题

Librosa依赖库安装配置完成后,在读取音频文件的时候可能会触发“audioread.exceptions.NoBackendError”,如下所示。

Ubuntu系统-FFmpeg安装及环境配置

  • 报错

audioread.exceptions.NoBackendError

  • 原因

这个问题主要是由于“librosa”音频处理库无法直接读取“mp3”格式的音频数据,需要调用“ffmpeg”后端读取音频文件所致。

具体原因可分为以下两点

  • 环境中没有安装“ffmpeg”。
  • 安装了“ffmpeg”,但现有环境配置无法指导librosa库调用处找到“ffmpeg”后端所在。

接下来将给出ffmpeg工具的完整安装配置过程,可根据环境中已有的配置情况选择性的完成以下步骤。

3.1 安装ffmpeg

3.1.1 安装wget (可选)

ubuntu环境下需要使用wget工具下载ffmpeg的源码安装包,因而首先需要下载安装wget工具(注:也可以在其他环境中下载ffmpeg的源码安装包,并将其上传到目标环境中即可)。

  • 命令行执行以下命令,安装wget
apt-get install -y wget 

3.1.2 安装ffmpeg

1.下载并解压安装包

命令行执行以下命令,下载ffmpeg的源码安装包

cd /usr/local/ wget https://johnvansickle.com/ffmpeg/release-source/ffmpeg-4.1.tar.xz 

可能存在无法通过认证检查的情况下载失败,此时根据提示,命令行中加入取消认证检查的选项即可,即执行以下命令

wget --no-check-certificate https://johnvansickle.com/ffmpeg/release-source/ffmpeg-4.1.tar.xz 

Ubuntu系统-FFmpeg安装及环境配置

下载完成后,当前目录(/usr/local/)下应该存在“ffmpeg-4.1.tar.xz”这个压缩包

Ubuntu系统-FFmpeg安装及环境配置

执行以下命令解压安装包

tar -xvf ffmpeg-4.1.tar.xz  

解压完成后,当前目录(/usr/local/)下将存在“ffmpeg-4.1”文件夹

Ubuntu系统-FFmpeg安装及环境配置

2.执行安装配置文件。

在当前路径(/usr/local/)下创建“ffmpeg”文件夹,作为ffmpeg工具的安装路径。

mkdir ffmpeg 

进入源码包,“config”程序,完成ffmpeg的安装配置。

cd ffmpeg-4.1 ./configure --enable-shared --prefix=/usr/local/ffmpeg  # --prefix选项指出ffmpeg的安装路径 

出现以下结果说明配置程序已经执行成功。

Ubuntu系统-FFmpeg安装及环境配置

Ubuntu系统-FFmpeg安装及环境配置

注:执行config程序时,可能会报“nasm/yasm not foun or too old. Use …”的错,此时需要先安装yams,然后再重新执行配置程序

Ubuntu系统-FFmpeg安装及环境配置

安装yasm的命令:

apt-get install yasm  

Ubuntu系统-FFmpeg安装及环境配置

3.执行编译&安装指令

执行以下命令,完成ffmpeg程序的编译和安装

Ubuntu系统-FFmpeg安装及环境配置

安装完成后,在配置中指出的安装路径(–prefix=/usr/local/ffmpeg)下存在以下内容,则说明ffmpeg安装成功。

Ubuntu系统-FFmpeg安装及环境配置

3.2 配置环境变量

1.修改环境变量

将ffmpeg的绝对路径添加到PATH环境变量中,以让系统能找到ffmpeg的安装路径。

vim ~/.bashrc  # 打开系统环境变量配置文件 

在文件中添以下内容。

export PATH="/usr/local/ffmpeg/bin:${PATH}" export LD_LIBRARY_PATH="/usr/local/ffmpeg/lib:{LD_LIBRARY_PATH}" 

Ubuntu系统-FFmpeg安装及环境配置

2.无法打开共享库文件

命令行使用“ffmpeg -h”或“/usr/local/ffmpeg/binffmpeg -h”命令检测ffmpeg安装情况时,出现以下内容。

“error while loading shared libraries: libavdevice.so.58: can not open shared object file or directory”

这是由于系统找不到ffmpeg的共享库所致。

在“/etc/ld.so.conf.d/”路径下创建文件“ffmpeg.conf”文件,在该文件中写入“/usr/local/ffmpeg/lib”

vim /etc/ld.so.conf.d/ffmpeg.conf   # 编辑文件,添加内容“/usr/local/ffmpeg/lib”后保存退出 cat /etc/ld.so.conf.d/ffmpeg.conf   # 查看ffmpeg.conf中的内容 ldonfig        # 执行ldconfig命令,使/etc/ld.so.conf.d/目录下新加入的配置信息生效 

Ubuntu系统-FFmpeg安装及环境配置

3.测试是否配置成功

命令行输入“which ffmpeg” 或 “ffmpeg -h”,出现以下内容,说明ffmpeg已经完全安装配置成功。

Ubuntu系统-FFmpeg安装及环境配置

3.3 修改库文件中的后端调用指令

若完成以上配置后,仍报错“audioread.exceptions.NoBackendError”,考虑以下解决方式。

  • 修改库文件,指出ffmpeg的绝对安装路径。

找到“ffdec.py”所在的位置,打开并编辑该文件,对第33行的内容做如下修改。

将 COMMAND = (‘ffmpeg’, ‘avconv’) 改为 COMMAND = (’/usr/local/ffmpeg/bin/ffmpeg’, ‘avconv’)

Ubuntu系统-FFmpeg安装及环境配置

Ubuntu系统-FFmpeg安装及环境配置

附言

说明:

根据不同环境的已有配置不同,可能遇到的问题会有所不同。即,以上问题可能不会都遇到,也可能会遇到以上没有列出的问题,若遇到以上未提及的问题,可根据报错信息在搜索引擎中查找解决方案。

本文转自:https://blog.csdn.net/qq_39456991/article/details/123346428